﻿using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.ComponentModel;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace GridData
{
    class CustomerInfoViewModel : INotifyPropertyChanged, IDisposable
    {

        public CustomerInfoViewModel()
        {
            CustomerDetails = new CustomersInfoRepository().GetCustomerDetails(50);
        }

        private ObservableCollection<Customers> customerDetails;
        public ObservableCollection<Customers> CustomerDetails
        {
            get
            {
                return customerDetails;
            }
            set
            {
                customerDetails = value;
                OnPropertyChanged("CustomerDetails");
            }
        }

        public event PropertyChangedEventHandler PropertyChanged;

        public void OnPropertyChanged(string propertyName)
        {
            PropertyChangedEventHandler handler = PropertyChanged;
            if (handler != null)
            {
                var e = new PropertyChangedEventArgs(propertyName);
                handler(this, e);
            }
        }

        public void Dispose()
        {
            CustomerDetails.Clear();
        }
    }
}
