﻿using System;
using System.Collections.Generic;
using System.IO;
using System.Linq;
using System.Runtime.InteropServices.WindowsRuntime;
using Windows.Foundation;
using Windows.Foundation.Collections;
using Windows.UI.Popups;
using Windows.UI.Xaml;
using Windows.UI.Xaml.Controls;
using Windows.UI.Xaml.Controls.Primitives;
using Windows.UI.Xaml.Data;
using Windows.UI.Xaml.Input;
using Windows.UI.Xaml.Media;
using Windows.UI.Xaml.Navigation;

// The Blank Page item template is documented at http://go.microsoft.com/fwlink/?LinkId=234238

namespace GridData
{
    /// <summary>
    /// An empty page that can be used on its own or navigated to within a Frame.
    /// </summary>
    public sealed partial class GettingStarted : UserControl, IDisposable
    {
        public GettingStarted()
        {
            this.InitializeComponent();
            this.DataContext = new OrderInfoViewModel();
            this.sfGrid.Loaded += SfGrid_Loaded;
            this.sfGrid.Unloaded += SfGrid_Unloaded;
        }

        private void SfGrid_Unloaded(object sender, RoutedEventArgs e)
        {
            this.sfGrid.ItemsSource = null;
            MessageDialog dialog = new MessageDialog("UnLoaded event fired.");
            dialog.ShowAsync();
        }

        private void SfGrid_Loaded(object sender, RoutedEventArgs e)
        {
            this.sfGrid.ItemsSource = (this.DataContext as OrderInfoViewModel).OrdersListDetails;
            MessageDialog dialog = new MessageDialog("Loaded event fired.");
            dialog.ShowAsync();
        }

        public void Dispose()
        {
            this.sfGrid.Loaded -= SfGrid_Loaded;
            this.sfGrid.Unloaded -= SfGrid_Unloaded;
            this.sfGrid.ItemsSource = null;
            this.sfGrid.Dispose();
            (this.DataContext as IDisposable).Dispose();
            this.DataContext = null;
        }
    }
}
